#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <errno.h>


char header[] = {"hlp07                       Copyright  1997 Mayr and Kockelhoff"};
char buffer[1024];

typedef struct {
	char *name;
	long size;
	void *next;
} Entry;

Entry *entry;

main(int argc, char *argv[])
{
	int i = 0;
	int n = 0;
	int fd;
	int len;
	int pages;
	long objsize;
	struct stat statbuf;
	Entry *p=NULL;
	char c;


	if (argc < 3) {
		fprintf(stderr,"usage: hc num_pages pagfile1 ... pagfilen image1 ... image?\n");
		exit(1);
	}

	pages = atoi(argv[1]);
	i++;

	while(++i<argc) {
		if ((fd = open(argv[i], O_RDONLY)) == -1) {
			sprintf(buffer, "Can't open file \"%s\"",argv[i]);
			perror(buffer);
			exit(3);
		}
		fstat(fd,&statbuf);
		objsize = statbuf.st_size;

		if (!p) {
			p = (Entry *)calloc(1,sizeof(Entry));
			entry = p;
		}
		else {
			p->next = (Entry *)calloc(1,sizeof(Entry));
			p = p->next;
		}
		close(fd);
		n++;
		p->name = strdup(argv[i]);
		p->size = objsize;
	}

	p = entry;
	write(1,header,64);
	objsize = htonl((long)pages);
	write(1,&objsize,sizeof(long));
	objsize = htonl((long)n);
	write(1,&objsize,sizeof(long));
	objsize = 72; 			//header + 2long

	for(i=0; i<n;i++) {
		objsize += strlen(p->name) + sizeof(char) + sizeof(long);
		p = p->next;
	}

	p = entry;
	objsize = htonl(objsize+4);
	write(1,&objsize,sizeof(long));

	for(i=0; i<n;i++) {
		c = strlen(p->name);
		write(1,&c,1);
		write(1,p->name,c);
		objsize = htonl(p->size);
		write(1,&objsize,sizeof(long));
		p = p->next;
	}
	p = entry;

	for(i=0; i<n;i++) {
		fprintf(stderr,"file: %s  size=%ld\n",p->name, p->size);
		fd = open(p->name, O_RDONLY);
		while ((len=read(fd,buffer,1024))>0) {
			write(1,buffer,len);
		}
		close(fd);
		p = p->next;
	}
}
