#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <errno.h>


#ifdef DO_ALIGN
extern inline long my_align(void *p);
#define MY_ALIGN(x) my_align(x)
#else
#define MY_ALIGN(x) (*(x))
#endif



char buffer[1024];

struct header {
    char header[64];
    long npages;
    long nitems;
    long offset;
};


typedef struct {
    char *name;
    long length;
    long offset;
} Toc;

Toc *toc;

static char *hf = NULL;
static int npages;
static int nitems;
static int current_page;
static int offset;
static char *page;
static int pagelen;

static int init_help()
{
    struct header *p;
    char *cp;
    int i;
    long loff = 0;

    p = (struct header *) hf;

    if (strncmp("hlp07", hf, 5)) {
	return 0;
    }
    npages = ntohl(p->npages);
    nitems = ntohl(p->nitems);
    offset = ntohl(p->offset);

    toc = (Toc *) calloc(nitems, sizeof(Toc));

    cp = hf + sizeof(struct header);

    for (i = 0; i < nitems; i++) {
	toc[i].name = cp;
	toc[i].offset = loff + offset;;
	toc[i].length = ntohl(MY_ALIGN((long *) ((cp + *cp) + 1L)));
	loff += toc[i].length;
	cp += *cp + sizeof(char) + sizeof(long);
    }
    return 1;
}




main(int argc, char *argv[])
{
    int fd;
    int i, ffd;
    size_t size;
    struct stat statbuf;

    if (argc < 2) {
	fprintf(stderr, "usage: huc help_file\n");
	exit(1);
    }
    if ((fd = open(argv[1], O_RDONLY)) == -1) {
	perror("Help file not found!");
	exit(2);
    }
    fstat(fd, &statbuf);
    size = statbuf.st_size;
    hf = mmap(0, size, PROT_READ, MAP_SHARED, fd, 0);


    if (!init_help()) {
	close(fd);
	hf = NULL;
	fprintf(stderr, "Not a valid help file\n");
	exit(3);
    }
    for (i = 0; i < nitems; i++) {
	fprintf(stdout, "%s\n", toc[i].name + 1);
	if (ffd = open(toc[i].name + 1, O_WRONLY|O_CREAT|O_TRUNC,
		S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH) == -1) {
	    perror("Can't create file!");
	    exit(4);
	}
	if (write(ffd, hf + toc[i].offset, toc[i].length) == -1) {
	    perror("Write error!");
	    exit(5);
	}
	close(ffd);
    }

    exit(0);
}
