
enum {
    SCREEN, POSTSCRIPT, COLORPS
};

extern FILE *ps;
extern int medium;

#define MAPMAXPERLINE 35	/* PostScript colormap data line length-1 */
#define MAXPERLINE    35	/* PostScript image data line length-1 */

#define PAPER_LETTER_HEIGHT	24.0
#define PAPER_LETTER_WIDTH	18.5
#define PAPER_LETTER_POINTS_H	1350
#define PAPER_LETTER_POINTS_W	1080

enum {
    LETTER, LEGAL, A4, A3	// Order is important. ->Printer dialog!
};

enum { PORTRAIT, LANDSCAPE };

typedef struct Page {
    char type;			/* page size, e.g. A or letter, B, A4, A3 */
    float ximagepos;
    float yimagepos;
    float maxhsize;
    float maxwsize;
    float xcenter;
    float ycenter;
    float default_height;
    float default_width;
    float yoffset;
    float height_adjust;
    float time_date_height;
} Page;


#define INTENSITY(color) (39L*color.red + 50L*color.green + 11L*color.blue)

typedef struct Image {
    float height;
    float width;
    float gamma;		/* gamma correction factor for brightening images */
    float width_frac;		/* fraction of horizontal raster to use for image */
    float height_frac;		/* fraction of vertical raster to use for image */
    int orientation;
    int pixels_width;
    int ps_width;
    int ps_height;
} Image;

typedef struct Flag {
    int logo;
    int black2white;		/* map black values to white */
    int date;
    int title;
    int time;
    int w;
    int h;
    int gamma;			/* gamma correction flag */
    int mono;			/* monochrome flag: TRUE = create monochrome PS */
    int inc_file;		/* include file flag: TRUE = append a file */
    int landscape;
    int portrait;
    int border;
    int invert;
    int error;			/* option error flag */
} Flag;

